#include <stdlib.h>
#include "list.h"

int initializeList(List *list)
{
  if (!list) return -1;
  list->length = 0;
  list->first = list->last = NULL;
  return 0;
}

int getLength(List *list)
{
  if (!list) return -1;
  return list->length;
}


int addItem(List *list, T *item)
{
  if (!list || !item) return -1;
  ListItem *p = (ListItem*)malloc(sizeof(ListItem));
  if (!p) return -1;
  p->item = *item;
  p->next = NULL;
  if (!list->first)
  {
    list->first = p;
  }
  else
  {
    list->last->next = p;
  }
  list->last = p;
  list->length++;
  return 0;
}

T* getItem(List *list, int pos)
{
  if (!list || pos < 0 || pos >= list->length) return NULL;
  int i;
  ListItem *tmp = list->first;
  for (i = 0; i < pos; i++)
  {
    tmp = tmp->next;
    if (!tmp) return NULL;
  }
  return &tmp->item;
}

T* findFirst(List *list, T* item)
{
  if (!list || !item) return NULL;
  ListItem *tmp = list->first;
  while (tmp)
  {
    if (tmp->item == *item) return &tmp->item;
    tmp = tmp->next;
  }
  return NULL;
}

int delItemP(List *list, int pos)
{
  if (!list || pos < 0 || pos >= list->length) return -1;
  if (!list->first) return -1;
  int i;
  ListItem *tmp = list->first;

  if (!pos)
  {
    list->first = tmp->next;
    free(tmp);
    if (list->length == 1)
      list->last = list->first;
  }
  else
  {
    ListItem *tmp2;    
    for (i = 0; i < pos; i++)
    {
      tmp2 = tmp;
      tmp = tmp->next;
    }
    if (tmp == list->last)
    {
      tmp2->next = NULL;
      list->last = tmp2;
      free(tmp);
    }
    else
    {
      tmp2->next = tmp->next;
      free(tmp);
    }
  }
  list->length--;
  return 0;
}

void delAll(List *list)
{
  if (!list) return;
  ListItem *tmp = list->first;
  ListItem *tmp2 = tmp;
  while (tmp)
  {
    tmp = tmp->next;
    free(tmp2);
    tmp2 = tmp;
  }
  initializeList(list);
}